<?php
/*
     Copyright (C) 2011  Likno Software

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//no direct access
if(!defined('_VALID_MOS') && !defined('_JEXEC')){
	die('Restricted access');
}
$mainframe = &JFactory::getApplication('site');	
$mainframe->registerEvent( 'onContentPrepare', 'plugin_lwtb_get_module_output' );

function plugin_lwtb_get_module_output( $context, &$row, &$params, $page=0 ){	
	$regex = '/{(tabs)\s*(.*?)}/i';	
	$matches = array();
	$preg_set_order = PREG_SET_ORDER;
   	preg_match_all($regex, $row->text, $matches, $preg_set_order);  
	
	foreach ($matches as $match){   		
		$module = '';
		$arguments = array();   		
		preg_match_all('/\[.*?\]/', $match[2], $arguments);		
		if ($arguments){
			foreach ($arguments as $i=>$argument){
				$module = preg_replace("/\[|]/", '', $argument);
			}
		}		
			
		$module_name = $module[0];	
		$module_class = 0;
		$module_style = 0;		
		
		$module_output = lwtb_load_tab(strip_tags($module_name), $module_class, $module_style);
			
		$row->text = preg_replace($regex, $module_output, $row->text, 1);
	}  
	
}

function lwtb_load_tab($module_name, $module_class, $module_style){
		
		
		
		$database = JFactory::getDBO();		
					
		$document	= &JFactory::getDocument();
		$renderer	= $document->loadRenderer('module');
		
		$contents = '';
		$module = null;
			
		//get module as object
		$query = "SELECT * FROM #__modules WHERE module = 'mod_lwtb_".$module_name."';";
		$database->setQuery($query);
		$module= $database->loadObject();
			
		
		
		if ($module!=null){
			$module->user = '';
		
		$params = array('style'=>$module_style);
		
		$contents = $renderer->render($module, $params);
		}
		return $contents;
			
	}

	
	function lwtb_add_code_to_bottom(){
	global $lwtb_module_Array;
	if (count($lwtb_module_Array)){
	$mainframe = JFactory::getApplication();	
		$uri = JFactory::getURI();
		$baseurl=$uri->root();
		$document = & JFactory :: getDocument();
		$doctype = $document->getType();
		if ($doctype == 'html' and !$mainframe->isAdmin()) {
			$body = JResponse :: getBody();
			$pieces = explode("</body>", $body);			
			$bodyNew = $pieces[0];
			foreach ($lwtb_module_Array as $lwtb_name){
			$bodyNew.="\n"."<!-- ******** BEGIN WEBTABSBUILDER CODE FOR $lwtb_name ******** -->"."\n".'
			<script charset="UTF-8" src="' . $baseurl . 'modules/mod_lwtb_'.$lwtb_name.'/lwtb_files/'.$lwtb_name .'.js" type="text/javascript"></script>'.
			"\n
			<!-- ******** END WEBTABSBUILDER CODE FOR $lwtb_name ******** -->
			\n";
			}
			$bodyNew.= "</body>".$pieces[1];
			JResponse::setBody($bodyNew);
		}
}
}
$mainframe->registerEvent( 'onAfterRender', 'lwtb_add_code_to_bottom');


?>